package nc.ui.gl.accbook;

import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;
import javax.swing.JFrame;
import nc.bd.accperiod.AccountCalendar;
import nc.bs.logging.Logger;
import nc.ui.gl.accbook.SubjectVersionEvent;
import nc.ui.gl.accbook.SubjectVersionListener;
import nc.ui.gl.common.CompConsts;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UICheckBox;
import nc.ui.pub.beans.UIComboBox;
import nc.ui.pub.beans.UIPanel;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.bd.period.AccperiodVO;
import nc.vo.bd.period2.AccperiodmonthVO;
import nc.vo.sm.cmenu.GlorgbookExtVO;

public class SubjVerChooser extends UIPanel {

   ClientEnvironment env = null;
   private UIComboBox ivjcbVersion = null;
   private UICheckBox ivjckEnableSubjVer = null;
   SubjVerChooser.IvjEventHandler ivjEventHandler = new SubjVerChooser.IvjEventHandler();
   private Vector listeners = new Vector();


   public SubjVerChooser() {
      this.initialize();
   }

   public SubjVerChooser(LayoutManager p0) {
      super(p0);
   }

   public SubjVerChooser(LayoutManager p0, boolean p1) {
      super(p0, p1);
   }

   public SubjVerChooser(boolean p0) {
      super(p0);
   }

   public void ckEnableSubjVer_ActionPerformed(ActionEvent actionEvent) {
      if(this.getcbVersion().isEnabled()) {
         this.getcbVersion().setEnabled(false);
      } else {
         this.getcbVersion().setEnabled(true);
      }

      this.fireSubjectVersionEvent(new SubjectVersionEvent(this, this.isEnableSubjVer(), this.getSubjVerYear(), this.getSubjVerPeriod()));
   }

   private void connEtoC1(ActionEvent arg1) {
      try {
         this.ckEnableSubjVer_ActionPerformed(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   public UIComboBox getcbVersion() {
      if(this.ivjcbVersion == null) {
         try {
            this.ivjcbVersion = new UIComboBox();
            this.ivjcbVersion.setName("cbVersion");
            this.ivjcbVersion.setEnabled(false);
            this.ivjcbVersion.setBounds(this.getckEnableSubjVer().getX() + this.getckEnableSubjVer().getWidth() + CompConsts.getSpace(), 0, CompConsts.getSelWidth("2022.01"), CompConsts.getTextHeight());
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjcbVersion;
   }

   public UICheckBox getckEnableSubjVer() {
      if(this.ivjckEnableSubjVer == null) {
         try {
            this.ivjckEnableSubjVer = new UICheckBox();
            this.ivjckEnableSubjVer.setName("ckEnableSubjVer");
            this.ivjckEnableSubjVer.setText(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000114"));
            this.ivjckEnableSubjVer.setBounds(0, 0, CompConsts.getCbxTxtWidth(this.ivjckEnableSubjVer.getText()), CompConsts.getTextHeight());
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjckEnableSubjVer;
   }

   public String getSubjVerPeriod() {
      String version = (String)this.getcbVersion().getSelectedItem();
      return version.substring(5, 7);
   }

   public String getSubjVerYear() {
      String version = (String)this.getcbVersion().getSelectedItem();
      return version.substring(0, 4);
   }

   private void handleException(Throwable exception) {
   }

   private void initConnections() throws Exception {
      this.getckEnableSubjVer().addActionListener(this.ivjEventHandler);
      this.getcbVersion().addItemListener(this.ivjEventHandler);
   }

   private void initialize() {
      try {
         this.setName("SubjVerChooser");
         this.setLayout((LayoutManager)null);
         this.add(this.getckEnableSubjVer());
         this.add(this.getcbVersion());
         this.setSize(this.getcbVersion().getWidth() + this.getcbVersion().getX(), CompConsts.getTextHeight());
         this.initConnections();
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.setClientEnv(ClientEnvironment.getInstance());
      this.refresh(((GlorgbookExtVO)this.env.getValue("pk_glorgbook")).getPeriodYear(), ((GlorgbookExtVO)this.env.getValue("pk_glorgbook")).getPeriodMonth());
   }

   public boolean isEnableSubjVer() {
      return this.getckEnableSubjVer().isSelected();
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         SubjVerChooser subjVerChooser = new SubjVerChooser();
         exception.setContentPane(subjVerChooser);
         exception.setSize(subjVerChooser.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void refresh(String year, String period) {
      try {
         this.getcbVersion().removeItemListener(this.ivjEventHandler);
         String e = ((GlorgbookVO)this.env.getValue("pk_glorgbook")).getPrimaryKey();
         AccountCalendar calendar = AccountCalendar.getInstanceByGlorgbook(e);
         AccperiodVO[] periodvos = calendar.getYearVOsOfCurrentScheme();
         String defaultVersion = year + "." + period;

         for(int i = 0; i < periodvos.length; ++i) {
            calendar.set(periodvos[i].getPeriodyear());
            AccperiodmonthVO[] monthvos = calendar.getMonthVOsOfCurrentYear();

            for(int j = 0; j < monthvos.length; ++j) {
               this.getcbVersion().addItem(periodvos[i].getPeriodyear() + "." + monthvos[j].getMonth());
            }
         }

         this.getcbVersion().setSelectedItem(defaultVersion);
         this.getcbVersion().addItemListener(this.ivjEventHandler);
      } catch (Exception var10) {
         Logger.debug("初始化科目版本错误！");
         var10.printStackTrace();
      }

   }

   public void setClientEnv(ClientEnvironment p_env) {
      this.env = p_env;
   }

   public synchronized void addSubjectVersionListener(SubjectVersionListener l) {
      this.listeners.addElement(l);
   }

   public void cbVersion_ItemStateChanged(ItemEvent itemEvent) {
      if(itemEvent.getSource().equals(this.getcbVersion())) {
         if(itemEvent.getStateChange() == 1) {
            this.fireSubjectVersionEvent(new SubjectVersionEvent(this, this.isEnableSubjVer(), this.getSubjVerYear(), this.getSubjVerPeriod()));
         }

      }
   }

   private void connEtoC2(ItemEvent arg1) {
      try {
         this.cbVersion_ItemStateChanged(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   public void fireSubjectVersionEvent(SubjectVersionEvent event) {
      Vector currentListeners = null;
      synchronized(this) {
         currentListeners = (Vector)this.listeners.clone();
      }

      for(int i = 0; i < currentListeners.size(); ++i) {
         SubjectVersionListener listener = (SubjectVersionListener)currentListeners.elementAt(i);
         listener.subjectVersionChanged(event);
      }

   }

   public synchronized void removeSubjectVersionListener(SubjectVersionListener l) {
      this.listeners.removeElement(l);
   }

   public void setSubjVerYear(String strYear) {
      this.getcbVersion().setSelectedItem(strYear);
   }

   public void setSubjVerPeriod(String strPeriod) {
      this.getcbVersion().setSelectedItem(strPeriod);
   }

   class IvjEventHandler implements ActionListener, ItemListener {

      public void actionPerformed(ActionEvent e) {
         if(e.getSource() == SubjVerChooser.this.getckEnableSubjVer()) {
            SubjVerChooser.this.connEtoC1(e);
         }

      }

      public void itemStateChanged(ItemEvent e) {
         if(e.getSource() == SubjVerChooser.this.getcbVersion()) {
            SubjVerChooser.this.connEtoC2(e);
         }

      }
   }
}
